include	PNGtoBMP.inc
include	gdi+.inc

EXTERN  pPNG:BYTE

PNG_FILE_SIZE = 1646
 
.data

szBMPfile           db 'image.bmp',0
ImgType             db 'image/bmp',0
message             db 'PNG converted to BMP',0
caption             db 'GDI+ test',0
CompressionLevel    dd  100
_EncoderQuality     GUID <01d5be4b5h,0fa4ah,0452dh,<09ch,0ddh,05dh,0b3h,051h,05h,0e7h,0ebh>>
dlibMove            _LARGE_INTEGER <0>
plibNewPosition     _LARGE_INTEGER <0>

.data?

StartupInfo         GdiplusStartupInput <?>
eps                 EncoderParameters <?>
buffer              db 32 dup(?)
pImageCodecInfo     dd ?
token               dd ?
PngImage            dd ?
pMemory             dd ?
pPNGstream          dd ?
pBMPstream          dd ?
hGlobal             dd ?

.code

start:

    mov     eax,OFFSET StartupInfo
    mov     GdiplusStartupInput.GdiplusVersion[eax],1
                                                                        ; must be always set to 1
    invoke  GdiplusStartup,ADDR token,ADDR StartupInfo,0
    
;   invoke  GdipCreateFromHDC,0,ADDR PngImage

    invoke  CreateStreamOnHGlobal,0,TRUE,ADDR pPNGstream

    mov     eax,pPNGstream
    push    0
    push    PNG_FILE_SIZE
    push    OFFSET pPNG
    push    eax
    mov     eax,DWORD PTR [eax]
    call    IStream.Write[eax]
    
    invoke  GdipLoadImageFromStream,pPNGstream,ADDR PngImage
												
    mov     esi,OFFSET eps
    mov     EncoderParameters.Count[esi],1                              ; process only one EncoderParameter structure
    lea     edx,[esi+EncoderParameters.Parameter.pGUID]

    invoke  MemCopy,ADDR _EncoderQuality,edx,16                         ; copy the GUID

    mov     EncoderParameters.Parameter.vType[esi],EncoderParameterValueTypeLong
    mov     EncoderParameters.Parameter.NumberOfValues[esi],1
                                                                        ; we have only one EncoderParameter structure

;   mov     EncoderParameters.Parameter.value[esi],OFFSET CompressionLevel
                                                                        ; set the JPEG compression level

    invoke  CreateStreamOnHGlobal,0,TRUE,ADDR pBMPstream
                                                                        ; create a new stream
                                                                        ; fDeleteOnRelease set to TRUE means that hGlobal
                                                                        ; will be released automatically by the IStream::Release method

    invoke  GetEncoderClsid,ADDR ImgType,ADDR pImageCodecInfo
                                                                        ; get the class identifier (CLSID) of the encoder
                                                                        ; The encoder can be bmp,jpeg,gif,tiff or png
	
    invoke  GdipSaveImageToStream,PngImage,pBMPstream,eax,ADDR eps
												; save the JPEG image to stream

    invoke  GetHGlobalFromStream,pBMPstream,ADDR hGlobal
                                                                        ; get the global handle to the stream
                                                                        ; created by CreateStreamOnHGlobal

    invoke  GlobalLock,hGlobal                                          ; get the address of the memory block containing the JPEG image
    mov     pMemory,eax

    mov     edx,OFFSET dlibMove
    mov     eax,pBMPstream
    push    OFFSET plibNewPosition                                      ; the displacement to be added to STREAM_SEEK_END
    push    STREAM_SEEK_END                                             ; move the pointer to end of the stream
    push    DWORD PTR [edx+4]                                           ; pass the structure dlibMove to the stack
    push    DWORD PTR [edx]
    push    eax
    mov     eax,DWORD PTR [eax]
    call    IStream.Seek[eax]                                           ; the IStream::Seek method changes the seek pointer to a new location

    invoke  WriteFileToDisc,ADDR szBMPfile,pMemory,DWORD PTR [plibNewPosition]
                                                                        ; DWORD PTR [plibNewPosition] = low-order DWORD of stream size

    mov     eax,pPNGstream
    call    ReleaseIStream
    mov     eax,pBMPstream	
    call    ReleaseIStream
       
    invoke  VirtualFree,pImageCodecInfo,0,MEM_RELEASE

    invoke  GdipDisposeImage,PngImage                                   ; release the image
    invoke  GdiplusShutdown,token                                       ; shutdown the GDI+ system
    invoke  MessageBox,0,ADDR message,ADDR caption,MB_OK
    invoke  ExitProcess,0

GetEncoderClsid PROC USES ebx edi sMimeType:DWORD,pMem:DWORD

LOCAL numEncoders:DWORD
LOCAL nSize:DWORD
LOCAL _buffer[32]:BYTE

    invoke  GdipGetImageEncodersSize,ADDR numEncoders,ADDR nSize
                                                                        ; get the number of available image encoders
                                                                        ; and the total size of the array
                                                                        ; of ImageCodecInfo structures
    invoke  VirtualAlloc,0,nSize,MEM_COMMIT,PAGE_READWRITE
    mov     edi,eax
    mov     edx,pMem                                                    ; = pImageCodecInfo
    mov     DWORD PTR [edx],eax
    invoke  GdipGetImageEncoders,numEncoders,nSize,edi
                                                                        ; get an array of ImageCodecInfo
                                                                        ; structures that contain information
                                                                        ; about the available image encoders
    invoke  UnicodeStr,sMimeType,ADDR _buffer
    mov     ebx,numEncoders
@@:
    invoke  ucCmp,ADDR _buffer,ImageCodecInfo.MimeType[edi]
    test    eax,eax
    jnz     @f
    sub     ebx,1
    add     edi,SIZEOF ImageCodecInfo
    jmp     @b
@@:
    mov     eax,edi                                                     ; = lea eax,[edi+ImageCodecInfo.Clsid]
    ret                                                                 ; eax holds the class identifier (CLSID)
                                                                        ; of the BMP encoder
GetEncoderClsid ENDP

ReleaseIStream  PROC

    push    eax
    mov     eax,DWORD PTR [eax]
    call    IStream.IUnknown.Release[eax]                               ; release the stream
    ret

ReleaseIStream ENDP

UnicodeStr	PROC USES esi Source:DWORD,Dest:DWORD
                                                                        ; convert a string to UNICODE
    mov     esi,Source
    mov     edx,Dest
    xor     eax,eax
    sub     eax,1
@@:
    add     eax,1
    movzx   ecx,BYTE PTR [esi+eax]
    mov     WORD PTR [edx+eax*2],cx
    test    ecx,ecx
    jnz     @b
    ret

UnicodeStr	ENDP

END start
